/*
 * create a simple password
 *
 * gcc makepass.c -o makepass -lcrypt
 */

#define _XOPEN_SOURCE

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>

char salt_key (void)
{
    char index;

    index = random ();
    while (
              ((index < 'A') || (index > 'Z'))
           && ((index < 'a') || (index > 'z'))
           && ((index < '0') || (index > '9'))
           && (index != '.')
           && (index != '/'))
    {
        index = random ();
    }

    return (index);
}

int main (int argc, char *argv [])
{
    char salt [2] ;

    if (argc != 2)
    {
	fprintf (stderr, "Usage : %s password\n", argv [0]);
	exit (1);
    }

    srandom (time (NULL));

    salt [0] = salt_key ();
    salt [1] = salt_key ();

    puts (crypt (argv[1], salt));
}
